/* ==========================================================================
/
/
/				[ZP] Extra Item : Medkit
/				   ( For Humans only )
/				      by The_Thing
/
/
/
/	Description :
/
/			You can now cure your self when  zombies had taken damage on your Health or Armor.
/			This can only be done by taking a certain amount of ammo packs out depending on your condition.
/
/
/
/	Cvars :
/
/			zp_medkit <1|0> - Enable or disable this plugin, default is 1
/			zp_medkitHP <1|0> - Enable or disable to medkit for HP, default is 1
/			zp_medkitAP <1|0> - Enable or disable to medkit for AP, default is 1
/			
/			// Medkit for HP
/			zp_medkit_cost90hp "21" - This is how much You will pay for cure your 90hp if You will have only 10hp
/			zp_medkit_cost80hp "19" - This is how much You will pay for cure your 80hp if You will have only 20hp
/			zp_medkit_cost70hp "17" - This is how much You will pay for cure your 70hp if You will have only 30hp
/			zp_medkit_cost60hp "15" - This is how much You will pay for cure your 60hp if You will have only 40hp
/			zp_medkit_cost50hp "13" - This is how much You will pay for cure your 50hp if You will have only 50hp
/			zp_medkit_cost40hp "11" - This is how much You will pay for cure your 40hp if You will have only 60hp
/			zp_medkit_cost30hp "9"  - This is how much You will pay for cure your 30hp if You will have only 70hp
/			zp_medkit_cost20hp "7"  - This is how much You will pay for cure your 20hp if You will have only 80hp
/			zp_medkit_cost10hp "5"  - This is how much You will pay for cure your 10hp if You will have only 90hp
/			zp_medkit_cost100hp "0" - This means that You have full HP already.
/
/			// Medkit for AP
/			zp_medkit_cost90ap "25" - Same as for HP only armor will be more expensive.
/			zp_medkit_cost80ap "23" -
/			zp_medkit_cost70ap "21" -
/			zp_medkit_cost60ap "19" -
/			zp_medkit_cost50ap "17" -
/			zp_medkit_cost40ap "15" -
/			zp_medkit_cost30ap "13" -
/			zp_medkit_cost20ap "11" -
/			zp_medkit_cost10ap "9"  -
/			zp_medkit_cost100ap "0" - This means that You have full AP already.
/
/
/
/	Commands :
/
/		say /medkithp or say_team /medkithp - to buy a HP cure randomly
/		say /medkitap or say_team /medkithp - to buy a AP cure randomly
/
/
/
/	Changelog :
/
/		09/11/2008 - v0.1 - First release
/		09/11/2008 - v0.2 - added armor feature too
/		11/11/2008 - v0.4 - change plugin name, converted all to fakemeta.
/
*/

#include <amxmodx>
#include <fakemeta>
#include <zombieplague>

#define PLUGIN_NAME 	"[ZP] Extra : Medkit"
#define PLUGIN_VERS 	"0.4"
#define PLUGIN_AUTHOR 	"The_Thing"

new g_item_name1[] = { "Medkit for HP" }
new g_item_name2[] = { "Medkit for AP" }
new g_medkit_toggle
new g_itemid_cureHP, g_medkitHP_toggle
new g_itemid_cureAP, g_medkitAP_toggle
new g_medkit_cost90hp, g_medkit_cost80hp, g_medkit_cost70hp, g_medkit_cost60hp, g_medkit_cost50hp,
g_medkit_cost40hp, g_medkit_cost30hp, g_medkit_cost20hp, g_medkit_cost10hp, g_medkit_cost100hp
new g_medkit_cost90ap, g_medkit_cost80ap, g_medkit_cost70ap, g_medkit_cost60ap, g_medkit_cost50ap,
g_medkit_cost40ap, g_medkit_cost30ap, g_medkit_cost20ap, g_medkit_cost10ap, g_medkit_cost100ap

public plugin_init() 
{
	register_plugin(PLUGIN_NAME, PLUGIN_VERS ,PLUGIN_AUTHOR)
	
	register_clcmd("say /medkithp","cureHP")
	register_clcmd("say_team /medkithp","cureHP")
	register_clcmd("say /medkitap", "cureAP")
	register_clcmd("say_team /medkitap", "cureAP")
	
	g_medkit_toggle = register_cvar("zp_medkit", "1")
	g_medkitHP_toggle = register_cvar("zp_medkitHP", "1")
	g_medkitAP_toggle = register_cvar("zp_medkitAP", "1")
	
	g_medkit_cost90hp = register_cvar("zp_medkit_cost90hp", "21")
	g_medkit_cost80hp = register_cvar("zp_medkit_cost80hp", "19")
	g_medkit_cost70hp = register_cvar("zp_medkit_cost70hp", "17")
	g_medkit_cost60hp = register_cvar("zp_medkit_cost60hp", "15")
	g_medkit_cost50hp = register_cvar("zp_medkit_cost50hp", "13")
	g_medkit_cost40hp = register_cvar("zp_medkit_cost40hp", "11")
	g_medkit_cost30hp = register_cvar("zp_medkit_cost30hp", "9")
	g_medkit_cost20hp = register_cvar("zp_medkit_cost20hp", "7")
	g_medkit_cost10hp = register_cvar("zp_medkit_cost10hp", "5")
	g_medkit_cost100hp = register_cvar("zp_medkit_cost100hp", "0")
	
	g_medkit_cost90ap = register_cvar("zp_medkit_cost90ap", "25")
	g_medkit_cost80ap = register_cvar("zp_medkit_cost80ap", "23")
	g_medkit_cost70ap = register_cvar("zp_medkit_cost70ap", "21")
	g_medkit_cost60ap = register_cvar("zp_medkit_cost60ap", "19")
	g_medkit_cost50ap = register_cvar("zp_medkit_cost50ap", "17")
	g_medkit_cost40ap = register_cvar("zp_medkit_cost40ap", "15")
	g_medkit_cost30ap = register_cvar("zp_medkit_cost30ap", "13")
	g_medkit_cost20ap = register_cvar("zp_medkit_cost20ap", "11")
	g_medkit_cost10ap = register_cvar("zp_medkit_cost10ap", "9")
	g_medkit_cost100ap = register_cvar("zp_medkit_cost100ap", "0")
	
	
	g_itemid_cureHP = zp_register_extra_item(g_item_name1, get_pcvar_num(g_medkit_cost90hp), ZP_TEAM_HUMAN)
	g_itemid_cureHP = zp_register_extra_item(g_item_name1, get_pcvar_num(g_medkit_cost80hp), ZP_TEAM_HUMAN)
	g_itemid_cureHP = zp_register_extra_item(g_item_name1, get_pcvar_num(g_medkit_cost70hp), ZP_TEAM_HUMAN)
	g_itemid_cureHP = zp_register_extra_item(g_item_name1, get_pcvar_num(g_medkit_cost60hp), ZP_TEAM_HUMAN)
	g_itemid_cureHP = zp_register_extra_item(g_item_name1, get_pcvar_num(g_medkit_cost50hp), ZP_TEAM_HUMAN)
	g_itemid_cureHP = zp_register_extra_item(g_item_name1, get_pcvar_num(g_medkit_cost40hp), ZP_TEAM_HUMAN)
	g_itemid_cureHP = zp_register_extra_item(g_item_name1, get_pcvar_num(g_medkit_cost30hp), ZP_TEAM_HUMAN)
	g_itemid_cureHP = zp_register_extra_item(g_item_name1, get_pcvar_num(g_medkit_cost20hp), ZP_TEAM_HUMAN)
	g_itemid_cureHP = zp_register_extra_item(g_item_name1, get_pcvar_num(g_medkit_cost10hp), ZP_TEAM_HUMAN)
	g_itemid_cureHP = zp_register_extra_item(g_item_name1, get_pcvar_num(g_medkit_cost100hp), ZP_TEAM_HUMAN)
	
	g_itemid_cureAP = zp_register_extra_item(g_item_name2, get_pcvar_num(g_medkit_cost90ap), ZP_TEAM_HUMAN)
	g_itemid_cureAP = zp_register_extra_item(g_item_name2, get_pcvar_num(g_medkit_cost80ap), ZP_TEAM_HUMAN)
	g_itemid_cureAP = zp_register_extra_item(g_item_name2, get_pcvar_num(g_medkit_cost70ap), ZP_TEAM_HUMAN)
	g_itemid_cureAP = zp_register_extra_item(g_item_name2, get_pcvar_num(g_medkit_cost60ap), ZP_TEAM_HUMAN)
	g_itemid_cureAP = zp_register_extra_item(g_item_name2, get_pcvar_num(g_medkit_cost50ap), ZP_TEAM_HUMAN)
	g_itemid_cureAP = zp_register_extra_item(g_item_name2, get_pcvar_num(g_medkit_cost40ap), ZP_TEAM_HUMAN)
	g_itemid_cureAP = zp_register_extra_item(g_item_name2, get_pcvar_num(g_medkit_cost30ap), ZP_TEAM_HUMAN)
	g_itemid_cureAP = zp_register_extra_item(g_item_name2, get_pcvar_num(g_medkit_cost20ap), ZP_TEAM_HUMAN)
	g_itemid_cureAP = zp_register_extra_item(g_item_name2, get_pcvar_num(g_medkit_cost10ap), ZP_TEAM_HUMAN)
	g_itemid_cureAP = zp_register_extra_item(g_item_name2, get_pcvar_num(g_medkit_cost100ap), ZP_TEAM_HUMAN)
}

public zp_extra_item_selected(player, itemid)
{
	if (itemid == g_itemid_cureHP)
	{
		if (is_user_alive(player) && !zp_get_user_zombie(player))
		{
			
			new hp = get_user_health(player)
			new cost = zp_get_user_ammo_packs(player)

	
			if (hp <= 10) 
			{
				cost = get_pcvar_num(g_medkit_cost90hp)
			}
			else if (hp <= 20) 
			{
				cost = get_pcvar_num(g_medkit_cost80hp)
			}
			else if (hp <= 30) 
			{
				cost = get_pcvar_num(g_medkit_cost70hp)
			}
			else if (hp <= 40) 
			{
				cost = get_pcvar_num(g_medkit_cost60hp)
			}
			else if (hp <= 50) 
			{
				cost = get_pcvar_num(g_medkit_cost50hp)
			}
			else if (hp <= 60) 
			{
				cost = get_pcvar_num(g_medkit_cost40hp)
			}
			else if (hp <= 70) 
			{
				cost = get_pcvar_num(g_medkit_cost30hp)
			}
			else if (hp <= 80) 
			{
				cost = get_pcvar_num(g_medkit_cost20hp)
			}
			else if (hp <= 90) 
			{
				cost = get_pcvar_num(g_medkit_cost10hp)
			}
			else if (hp == 100) 
			{
				cost = get_pcvar_num(g_medkit_cost100hp)
			}
			
			new cash = zp_get_user_ammo_packs(player)

			if (cash < cost) 
			{
				client_print(player,print_chat,"[ZP] You don't have enough ammo packs to cure!")
				return PLUGIN_HANDLED
			}

			if (cash >= cost) 
			{
				new ammo_packs = zp_get_user_ammo_packs(player) - cost
				zp_set_user_ammo_packs(player, ammo_packs)

				fm_set_user_health(player, 100)
				set_pev(player, pev_health, float(100))

				client_print(player, print_chat, "[ZP] You have cured self, this cost to You %d ammo packs",cost)
				return PLUGIN_HANDLED
			}
		}
	}
	if (itemid == g_itemid_cureAP)
	{
		new ap = get_user_armor(player)
		new costap = zp_get_user_zombie(player)
	
		if (ap <= 10)
		{
			costap = get_pcvar_num(g_medkit_cost90ap)
		}
		else if (ap <= 20)
		{
			costap = get_pcvar_num(g_medkit_cost80ap)
		}
		else if (ap <= 30)
		{
			costap = get_pcvar_num(g_medkit_cost70ap)
		}
		else if (ap <= 40)
		{
			costap = get_pcvar_num(g_medkit_cost60ap)
		}
		else if (ap <= 50)
		{
			costap = get_pcvar_num(g_medkit_cost50ap)
		}
		else if (ap <= 60)
		{
			costap = get_pcvar_num(g_medkit_cost40ap)
		}
		else if (ap <= 70)
		{
			costap = get_pcvar_num(g_medkit_cost30ap)
		}
		else if (ap <= 80)
		{
			costap = get_pcvar_num(g_medkit_cost20ap)
		}
		else if (ap <= 90)
		{
			costap = get_pcvar_num(g_medkit_cost10ap)
		}
		else if (ap == 100)
		{
			costap = get_pcvar_num(g_medkit_cost100ap)
		}
	
		new cashap = zp_get_user_ammo_packs(player)
	
		if (cashap < costap) 
		{
			client_print(player, print_chat, "[ZP] You don't have enough ammo packs to cure Armor!")
			return PLUGIN_HANDLED
		}
		
		if (cashap >= costap) 
		{
			new ammo_packs2 = zp_get_user_ammo_packs(player) - costap
			zp_set_user_ammo_packs(player, ammo_packs2)

			fm_set_user_armor(player, 100)
			set_pev(player, pev_armorvalue, float(100))

			client_print(player,print_chat,"[ZP] You have cured armor, this cast to You %d ammo packs",costap)
			return PLUGIN_HANDLED
		}
	}
	return PLUGIN_CONTINUE
}

public cureHP(id) 
{
	if (!get_pcvar_num(g_medkit_toggle)) 
		return PLUGIN_HANDLED
		
	if (!get_pcvar_num(g_medkitHP_toggle))
		return PLUGIN_HANDLED
		
	if (!is_user_alive(id) || zp_get_user_zombie(id))
		return PLUGIN_HANDLED

	new hp = get_user_health(id)
	new cost = zp_get_user_ammo_packs(id)

	
	if (hp <= 10) 
	{
		cost = get_pcvar_num(g_medkit_cost90hp)
	}
	else if (hp <= 20) 
	{
		cost = get_pcvar_num(g_medkit_cost80hp)
	}
	else if (hp <= 30) 
	{
		cost = get_pcvar_num(g_medkit_cost70hp)
	}
	else if (hp <= 40) 
	{
		cost = get_pcvar_num(g_medkit_cost60hp)
	}
	else if (hp <= 50) 
	{
		cost = get_pcvar_num(g_medkit_cost50hp)
	}
	else if (hp <= 60) 
	{
		cost = get_pcvar_num(g_medkit_cost40hp)
	}
	else if (hp <= 70) 
	{
		cost = get_pcvar_num(g_medkit_cost30hp)
	}
	else if (hp <= 80) 
	{
		cost = get_pcvar_num(g_medkit_cost20hp)
	}
	else if (hp <= 90) 
	{
		cost = get_pcvar_num(g_medkit_cost10hp)
	}
	else if (hp == 100) 
	{
		cost = get_pcvar_num(g_medkit_cost100hp)
	}

	new cash = zp_get_user_ammo_packs(id)

	if (cash < cost) 
	{
		client_print(id,print_chat,"[ZP] You don't have enough ammo packs to cure Health!")
		return PLUGIN_HANDLED
	}

	if (cash >= cost) 
	{
		new ammo_packs = zp_get_user_ammo_packs(id) - cost
		zp_set_user_ammo_packs(id, ammo_packs)

		fm_set_user_health(id,100)
		set_pev(id, pev_health, float(100))
		
		client_print(id,print_chat,"[ZP] You have cured self, this cost to You %d ammo packs",cost)
		return PLUGIN_HANDLED
	}

	return PLUGIN_HANDLED
}

public cureAP(id)
{
	if (!get_pcvar_num(g_medkitHP_toggle))
		return PLUGIN_HANDLED
	
	if (!get_pcvar_num(g_medkitAP_toggle))
		return PLUGIN_HANDLED
		
	if (!is_user_alive(id) || zp_get_user_zombie(id))
		return PLUGIN_HANDLED
		
	new ap = get_user_armor(id)
	new costap = zp_get_user_zombie(id)
	
	if (ap <= 10)
	{
		costap = get_pcvar_num(g_medkit_cost90ap)
	}
	else if (ap <= 20)
	{
		costap = get_pcvar_num(g_medkit_cost80ap)
	}
	else if (ap <= 30)
	{
		costap = get_pcvar_num(g_medkit_cost70ap)
	}
	else if (ap <= 40)
	{
		costap = get_pcvar_num(g_medkit_cost60ap)
	}
	else if (ap <= 50)
	{
		costap = get_pcvar_num(g_medkit_cost50ap)
	}
	else if (ap <= 60)
	{
		costap = get_pcvar_num(g_medkit_cost40ap)
	}
	else if (ap <= 70)
	{
		costap = get_pcvar_num(g_medkit_cost30ap)
	}
	else if (ap <= 80)
	{
		costap = get_pcvar_num(g_medkit_cost20ap)
	}
	else if (ap <= 90)
	{
		costap = get_pcvar_num(g_medkit_cost10ap)
	}
	else if (ap == 100)
	{
		costap = get_pcvar_num(g_medkit_cost100ap)
	}
	
	new cashap = zp_get_user_ammo_packs(id)
	
	if (cashap < costap) 
	{
		client_print(id,print_chat,"[ZP] You don't have enough ammo packs to cure Armor!")
		return PLUGIN_HANDLED
	}
	
	if (cashap >= costap) 
	{
		new ammo_packs2 = zp_get_user_ammo_packs(id) - costap
		zp_set_user_ammo_packs(id, ammo_packs2)

		fm_set_user_armor(id,100)
		set_pev(id, pev_armorvalue, float(100))

		client_print(id,print_chat,"[ZP] You have cured armor, this cast to You %d ammo packs",costap)
		return PLUGIN_HANDLED
	}

	return PLUGIN_HANDLED
}

stock fm_set_user_armor(index, armor) 
{
	set_pev(index, pev_armorvalue, float(armor));

	return 1;
}

stock fm_set_user_health(index, health) 
{
	health > 0 ? set_pev(index, pev_health, float(health)) : dllfunc(DLLFunc_ClientKill, index);

	return 1;
}
